function [fn,aveData,ts,elapsed,stimdelay,f,dyyl] = tdtcsd(varargin)
% this will open a tdt file, and find all records of type "SSwp", which is
% block store, which is an episode of predefined number of samples, with a
% pre trigger period.  then it will display all channels, in order from top
% to bottom and create one graph for each sweep, along with CSD, if enabled

%%  here are the custom defaults, change here to modify output behavior

% N.B. FOR EVOKED RESPONSES THAT HAVE LARGE RESPONSES, ...
% turn trendnormalizing off 
% .  JRH 3/22/2018
% startdir='/home/shared/Brielle/Scn8a PFC LFPs'; % starting directory to read files. Set to empty to use current directory

startdir=[]'; % starting directory to read files. Set to empty to use current directory
baselineoffset=false; % calculate offset from first part of trace and the do DC offset to bring to zero
droppedChannels=[];
droppedEpisodes=[];
zeroedChannels = [];
data=[1];
polarityswitch=false; % should be false (0-1) for flipped polarity
trendnormalizing=true;
filtering = true;
hp=0.001; % hz low pass filtering
lp=200; % hz high pass filtering
lfpgain=-0.025; %vertical scaling for lfp plot
csdgain=-2;  % vertical scaling for csd plot
contourgain=2.5;  % max (& min) for contour plot
averaging=false;
saving=false;  % file save of plot
plottingcsd=false; % include lower plots of CSD calculation, not just lfp
zooming=false; % include second column zoomed in on time
quashingnoisy=false; % number of SDs that trace variance has to be above to reject from average
quashthreshold=10;  % microvolts
alternating=false;
baselinepct=3; % percent of baseline to use for offset or trend normalizing (100% for former, 50% for latter)
plottingzero=true; % place dotted zero lines for each channel in CSD
fillingcsd=false;
stimdelay=.032; %s, position of stim within sweep
prestimtime=.03; % s amount of time to display before stim
poststimtime=0.15; % s, amount of post-stim response to show, 0.030 for 0.06 ms
usetdtstimtime=true;
measuring=true;
meas_time=.15;
meas_dur=.05;
displayall=false;
firstchan=1;
lastchan=16;
chans='1..16';
pause_dur=1;
earlydetrend=false;
plottingcontour=false;
fnamepre='';
subtract=false;
vectorize=false;
bluewhiteredmap=false;
resample=1;
numcsdsteps=25;
swps='all';
useDirr=false;
nomenu=0;
TanyaAnalysis=false;
LogCSD=false;
fileType='tev';
paramspath='/home/shared/matlabscripts/LFPparams/';
pvpmod(varargin); % convert input parameter name variable names to instances of those variables
%start with defaults, or the parameter file passed in arguments
if ~exist('paramfile')
    paramfile='default';
end
load([paramspath paramfile '.mat']); % default parameter file, since not using dialogbox
v2struct(Answer);
% set up dialogbox structure
defans = struct([]);
dlgcols=3;
Options.ReadButton = 'on';
Options.SaveButton = 'on';
Options.ApplyButton = 'on';
simplewidth=50; 
notdone=1;

while notdone
      if exist('fn')
        inputfiles={fn};
        [~,~,ext]=fileparts(fn);
        Answer.fileType=ext(2:end);
    else
        if useDirr
            [file,fn]=uigetfile([startdir '/*.' fileType],'Select Parent Folder to Crawl Through');
            if ~file
                display('Cancelled and done');
                return
            end
            [~,~,inputfiles]=dirr([fn '/*.' fileType],'name');
        else
            inputfiles = uipickfiles('FilterSpec',startdir);
                if ~iscell(inputfiles) % cancel button hit , not a cell but a zero
                     display('Cancelled and done');
                    return
                end
        end
    end
    
   startdir1=inputfiles{1};
      lastslash=find(ismember(startdir1,'/'),1,'last'); %remove last part of path to get to parent directory
      startdir=startdir1(1:lastslash-1);

    analyzing=true;
    while analyzing
       
        editing=1;
        while editing
            currentpos=0; %initialize
%             [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
%             formats(currentrow,currentcol).type='edit';
%             formats(currentrow,currentcol).format='text';
%             formats(currentrow,currentcol).size = 250;
%             prompt(currentpos,:)={'Directory', 'startdir',[]};
%             defans(1).startdir = startdir;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='list';
            formats(currentrow,currentcol).format='text';
            formats(currentrow,currentcol).style = 'radiobutton';
            formats(currentrow,currentcol).items = {'tev','openephys'};
            prompt(currentpos,:)={'File type', 'fileType',[]};
            defans(1).fileType = fileType;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Invert Probe# Polarity', 'polarityswitch',[]};
            defans.polarityswitch = polarityswitch;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Average sweeps', 'averaging',[]};
            defans.averaging = averaging;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Offset Baseline', 'baselineoffset',[]};
            defans.baselineoffset = baselineoffset;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'integer';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [1 100]; % percentage
            prompt(currentpos,:)={'% swp for baseline [1-100]', 'baselinepct',[]};
            defans.baselinepct = baselinepct;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Linear Detrend', 'trendnormalizing',[]};
            defans.trendnormalizing = trendnormalizing;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Early Detrend', 'earlydetrend',[]};
            defans.earlydetrend = earlydetrend;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'integer';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [1 1000]; % resample number
            prompt(currentpos,:)={'downsample interval', 'resample',[]};
            defans.resample = resample;
            
if 1
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'integer';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [1 16]; % percentage
            prompt(currentpos,:)={'First Channel', 'firstchan',[]};
            defans.firstchan = firstchan;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'integer';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [1 16]; % percentage
            prompt(currentpos,:)={'Last Channel', 'lastchan',[]};
            defans.lastchan = lastchan;
            
end
if 1
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'text';
            formats(currentrow,currentcol).size = simplewidth;            
            %formats(currentrow,currentcol).limits = [1 16]; % percentage
            prompt(currentpos,:)={'Channel List', 'chans',[]};
            defans.chans = chans;
end
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Quash noisy swps from ave', 'quashingnoisy',[]};
            defans.quashingnoisy = quashingnoisy;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='edit';
            formats(currentrow,currentcol).format = 'text';
            formats(currentrow,currentcol).size = simplewidth;
            prompt(currentpos,:)={'Sweeps', 'swps',[]};
            defans.swps = swps;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.1 10000]; % percentage
            prompt(currentpos,:)={'Threshold for quashing (uV)', 'quashthreshold',[]};
            defans.quashthreshold = quashthreshold;
                        
            % blank space
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Filter', 'filtering',[]};
            defans.filtering = filtering;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.001 10000]; % percentage
            prompt(currentpos,:)={'HP Filter Cutoff', 'hp',[]};
            defans.hp = hp;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.001 10000]; % percentage
            prompt(currentpos,:)={'LP Filter Cutoff', 'lp',[]};
            defans.lp = lp;
                    
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Zoom in', 'zooming',[]};
            defans.zooming = zooming;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Use TDT stim. time', 'usetdtstimtime',[]};
            defans.usetdtstimtime = usetdtstimtime;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.0001 10000]; % percentage
            prompt(currentpos,:)={'Stim. delay (s)', 'stimdelay',[]};
            defans.stimdelay = stimdelay;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.00001 10000]; % percentage
            prompt(currentpos,:)={'PreStim. time (s)', 'prestimtime',[]};
            defans.prestimtime = prestimtime;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.00011 10000]; % percentage
            prompt(currentpos,:)={'PostStim. time (s)', 'poststimtime',[]};
            defans.poststimtime = poststimtime;
          
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [-10000 10000]; % percentage
            prompt(currentpos,:)={'LFP vertical gain (mV)', 'lfpgain',[]};
            defans.lfpgain = lfpgain;               
 
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Measure LFP/CSD', 'measuring',[]};
            defans.measuring = measuring;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.01 10000];
            prompt(currentpos,:)={'Measurement time (s)', 'meas_time',[]};
            defans.meas_time = meas_time;
 
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.01 10000];
            prompt(currentpos,:)={'Measurement duration (s)', 'meas_dur',[]};
            defans.meas_dur = meas_dur;

                  [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Show all traces', 'displayall',[]};
            defans.displayall = displayall;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Save PDF', 'saving',[]};
            defans.saving = saving;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Plot CSD', 'plottingcsd',[]};
            defans.plottingcsd = plottingcsd;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [-10000 10000]; % percentage
            prompt(currentpos,:)={'CSD vertical gain', 'csdgain',[]};
            defans.csdgain = csdgain;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.01 10000]; % percentage
            prompt(currentpos,:)={'Contourplot max', 'contourgain',[]};
            defans.contourgain = contourgain;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'integer';
            formats(currentrow,currentcol).size = simplewidth;
            prompt(currentpos,:)={'# Contours', 'numcsdsteps',[]};
            defans.numcsdsteps= numcsdsteps;
                        
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type = 'edit';
            formats(currentrow,currentcol).format = 'float';
            formats(currentrow,currentcol).size = simplewidth;
            formats(currentrow,currentcol).limits = [0.01 10000];
            prompt(currentpos,:)={'Pause time per sweep (s)', 'pause_dur',[]};
            defans.pause_dur = pause_dur;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Plot zerolines CSD', 'plottingzero',[]};
            defans.plottingzero = plottingzero;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Fill CSD blue/red', 'fillingcsd',[]};
            defans.fillingcsd = fillingcsd;
            
          [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Plot CSD contour', 'plottingcontour',[]};
            defans.plottingcontour = plottingcontour;
            
      [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Blue/White/Red Contours', 'bluewhiteredmap',[]};
            defans.bluewhiteredmap = bluewhiteredmap;
            
      
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Vectorize PDF', 'vectorize',[]};
            defans.vectorize = vectorize;
            
            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Use Dirr', 'useDirr',[]};
            defans.useDirr = useDirr;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Tanya Analysis', 'TanyaAnalysis',[]};
            defans.TanyaAnalysis = TanyaAnalysis;

            [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
            formats(currentrow,currentcol).type='check';
            prompt(currentpos,:)={'Log value for CSD', 'LogCSD',[]};
            defans.LogCSD = LogCSD;


            
            if size(inputfiles,2)==2
                
                [currentrow,currentcol,currentpos]=calcdlgpos(currentpos,dlgcols);
                formats(currentrow,currentcol).type='check';
                prompt(currentpos,:)={'Algebraic subtraction', 'subtract',[]};
                defans.subtract = subtract;
            else
                subtract=false;
            end
            
            if analyzing
                [Answer,Cancelled] = inputsdlgjh(prompt,sprintf('Options for MUA - %d channels - %d sweeps - %s',size(data,2),size(data,1),startdir),formats,defans,Options);
            else
                Cancelled=1;
            end
            if Cancelled==1
                  if exist('filename')
                      return
                  end
                       clear fn;
                editing=0;
                analyzing=0; % this look breaker does not seem to work.  the desired behavior is to return to file selection menu, when cancelling from run menu
            end
            if Cancelled==10
                % save parameter file
                [file,path] = uiputfile(paramspath,...
                    'Select file name to save');
                if file
                    save(fullfile(path,file),'Answer')
                end
            end
            if Cancelled==100
                % read parameter file
                [file,path] = uigetfile(paramspath,...
                    'Select param file to load');
                if file
                    load(fullfile(path,file));
                    v2struct(Answer);
                end
            end
            if ~Cancelled
                editing=0;  % ultimately want to put in a test for saving options here
            end
        end
        if analyzing
            v2struct(Answer);  % this takes the return values from the dialog box and assigns them into the original variables
            
            polarity=1;
            if polarityswitch
                polarity=-1;
            end
            %%
            
            
            exts ='.tev';
            for f = 1:numel(inputfiles)
                  try 
                    [fn, path, fnamepre, ext] = fLoop(f,inputfiles,exts);
                    
                    %% read episodes
                    [data,ts,elapsed,stimdelaytdt]=tdtepisodes(fn,'SSwp');
                    
                    data=data(:,firstchan:lastchan,:);
                    swpnums=1:size(data,1);
                    if ~strcmp(swps,'all')
                        % user has specified the sweeps to use.  now check
                        % it
                        
                        % than once
                        swpnums=validatevector(swps,size(data,1));
                            if ~(swpnums(1)<1)
                                data=data(swpnums,:,:);
                            end
                        
                    end
                    %  probeUpsideDown=1;
                    %  if probeUpsideDown
                    %      data=flipdim(data,2);
                    %  end
                    
                    %% average data across stimulus intensities
                    numpointsinbaseline=int32(size(data,3)*baselinepct/100);
                    if baselineoffset  % i.e. if the a/c coupling on the pz5 is turned off as it should be for slow responses
                        
                        for j=1:size(data,1)
                            for i=1:size(data,2)
                                % calculate mean voltage for first x (e.g. 100) pts
                                baseline=mean(data(j,i,1:numpointsinbaseline));
                                % now offset by subtracting mean of first pts
                                data(j,i,:)=data(j,i,:)-baseline;
                            end
                        end
                    end
                    
                    if droppedChannels
                        data(:,droppedChannels,:)=[];
                    end
                    
                    if zeroedChannels
                        data(:,:,zeroedChannels) = zeros(1,size(data,3));
                    end
                    
                    
                    nSweeps=size(data,1);
                    %postStimDelay= 0.0025;
                    %stimInd = find(ts(1,:)>stimdelay+postStimDelay,1,'first');
                    %endInd =  find(ts >= 0.060, 1, 'first');
                    nChannels = size(data,2);
                    nChannelsCSD = nChannels-2;
                    si=(ts(2)-ts(1)); % assumes that the sample rate is constant, and indicated by first sample interval
                    Fs= 1/si;
                    
                    if trendnormalizing  % i.e. if the a/c coupling on the pz5 is turned off as it should be for slow responses
                        for j=1:size(data,1) % each sweep/episode
                            for i=1:size(data,2) % each channel within sweep
                                d1=squeeze(data(j,i,:));
                                % calculate the linear trend from first and last points
                                trendtm=si*double([1:numpointsinbaseline size(data,3)-numpointsinbaseline+1:size(data,3)]);
                                trendpts=([d1(1:numpointsinbaseline)' d1(end-numpointsinbaseline+1:end)' ]);                                
                                if earlydetrend
                                    trendtm=si*double([1:numpointsinbaseline]); % the order matters.  need to start with si as it is a double!  
                                    trendpts=([d1(1:numpointsinbaseline)' ]);
                                end
                                [R,m,b]=regression(trendtm,trendpts);
                               % X=[ones(size(trendtm)); trendtm];
                               % beta=regress(trendpts',X');
                               % s=sprintf('swp %d chan %d R %d m %d b %d m2 %d b2 %d',j,i,R,m,b,beta(1),beta(2));
                               % disp(s);
                               trendx=(1:size(data,3))*si;
                               trendline=trendx*m+b; % now offset by subtracing mean of first pts
                               data(j,i,:)=d1-trendline';
                               %figure; plot(squeeze(data(j,i,1:numpointsinbaseline)));
                            end
                        end
                    end
                    if averaging
                        if quashingnoisy
                            v=var(data,0,3); %look at variance in each sweep and channel
                            m=mean(v');
                            v1=var(v');
                            m2=mean(mean(v));
                            s2=std(std(v));
                            %quashthresh=1e-8;  % need to calculate this based on statistics of data
                            % this guess only works for small, light evoked responses,
                            % without big stim artifacts, not for evoked.
                            %                quashthresh=m2*quashingnoisy; %*s2;
                            for i=1:size(data,2) % each channel
                                dropped=find(v(:,i)>quashthreshold*1e-9);
                                kept=find(v(:,i)<quashthreshold*1e-9);
                                if dropped
                                    a=sprintf('Dropping episodes %s from channel %d',mat2str(dropped),i);
                                    disp(a);
                                end
                                mean1(1,i,:)=mean(data(kept,i,:));
                            end
                            Dataprefilt=mean1*polarity;
                        else
                            Dataprefilt = polarity*mean(data);
                        end
                    else
                        Dataprefilt=polarity*data;
                    end
                    aveData=[];
                    if filtering
                        for i=1:size(Dataprefilt,1)
                            % filtfilt2(d,hp,lp,Fs,varargin)
                            for ch=1:nChannels
                                aveData(i,ch,:) = filtfilt2(squeeze(Dataprefilt(i,ch,:)),hp,lp,Fs, 1);
                            end
                        end
                    else
                        aveData=Dataprefilt;
                    end
                    
                    if alternating
                        kept=(1:int32(size(aveData,1)/2))*2; % i.e. 1,3,5, etc
                        aveData=aveData(kept,:,:);
                    end
                    
                    if droppedEpisodes
                        data(droppedEpisodes,:,:)=[];
                    end
                    if resample>1
                        for k=1:size(aveData,1)
                            for l=1:size(aveData,2)
                                aveData1(k,l,:)=downsample(aveData(k,l,:),resample,floor(resample/2));
                            end
                        end
                        aveData=aveData1;
                        clear aveData1;
                        si=si*resample;
                        ts=(1:size(aveData,3))*si;
                        Fs= 1/si;
                    end
                    if TanyaAnalysis
                        % do this here to use the trend normalization done
                        % in gui form
                        %Fs
                        TanyaCSDanalysis(data,ts,Answer,stimdelaytdt,fnamepre)    
                    end
                    
                    %% calculate CSD
                    %spacing=.1; % this is dangerous, spacing defined locally in multiple routines, and may not agree.  would be better to define it here in the top level routing and pass as variable to subroutines.
                    % dyyl1=csdcalctnw(aveData,spacing);  %calculate csd on raw, non boxcar averaged data
                    
                    %% plot LFP and CSD
                    parts=strsplit(fn,'/');
                    spath='';
                    for p=1:size(parts,2)-2
                        spath=[spath parts{p} '/'];
                    end
                    startdir=spath;
                    
                    if subtract && f==1
                        aveData2=aveData;
                    end
                    if subtract && f==2
                        aveData=aveData2-aveData;
                    end
                    if ~subtract || (subtract && f==2)
                        
                    if measuring
                        spacing=0.1;
                        dyyl=squeeze(csdcalc3(data,spacing));
                        
                        meas_samp=int32(meas_time/si);
                        meas_samp2=int32((meas_time+meas_dur)/si);
                        meas1=mean(data(:,:,meas_samp:meas_samp2),3);
                        meas2=mean(dyyl(:,:,meas_samp:meas_samp2),3);
                        fid = fopen([spath fnamepre '_lfp.csv'], 'w' );
                        fprintf( fid, '"%s"\n',fn );                        
                        for jj = 1 : size(meas1,1) % the below correction deals with assumes GMT to PDT
                            fprintf( fid, '"%s",%ld', datetime(elapsed(jj)-60*60*7,'ConvertFrom','posixtime'),int32(elapsed(jj)));
                            for kk=1:size(meas1,2)
                                fprintf( fid, ',%d', meas1(jj,kk));
                            end
                            fprintf( fid, '\n');
                        end
                        fclose( fid );
                        fid = fopen([spath fnamepre '_csd.csv'], 'w' );
                        fprintf( fid, '"%s"\n',fn );                                                
                        for jj = 1 : size(meas2,1)
                            fprintf( fid, '"%s",%i', datetime(elapsed(jj)-60*60*7,'ConvertFrom','posixtime'),int32(elapsed(jj)));
                            for kk=1:size(meas2,2)
                                fprintf( fid, ',%d', meas2(jj,kk));
                            end
                            fprintf( fid, '\n');
                        end
                        fclose( fid );
                    end
                    for i =1:size(aveData,1)
                        fignum=1;
                        
                        if numel(inputfiles)>1 && ~subtract
                            fignum=10+f;
                        end
                        fg=figure(fignum);
                        if vectorize
                            fg.Renderer='Painters'; %This forces matlab to save as a vector file,
                        else
                            fg.Renderer='OpenGL';
                        end
                        %retaining all the resolution.  The file is much much larger then, and
                        %slower to render, but can be imported into illustrator or Coreldraw.
                        %close all;
                        
                        swp=swpnums(i);
                        if averaging
                            swp=0;
                        end
                        
                        % if ~evoked
                        %    displaytdtsweeps(fn,aveData(i,:,:),ts,elapsed,'plottingcsd',plottingcsd,'zooming',zooming,'swp',swp); %11 5HT 13 for med
                        %else
                        %'plottingcsd',plottingcsd,'zooming', ...
                        %    zooming,'swp',swp,'displayoffset1',lfpgain,'displayoffset2', ...
                        %    csdgain,'colorscale', contourgain, 'plottingzero',plottingzero, ...
                        %    'fillingcsd',fillingcsd);
                        %end
                        if displayall
                              displaytdtsweeps(fn,aveData,ts,elapsed,stimdelaytdt,swp,Answer);
                                                                    else
                              displaytdtsweeps(fn,aveData(i,:,:),ts,elapsed,stimdelaytdt,swp,Answer);
                        end
                        if saving 
                            if ~displayall || displayall && i == size(aveData,1)
                            % save file in path one folder below the tsv folder
                            
                            swp=sprintf('Sweep_%03d',swpnums(i));
                            %if displayall
                             %   swp=sprintf('Sweeps_%03d-%03d',1,i);
                            %end
                            if averaging || displayall
                                continuous=diff(swpnums);
                                swp1='';
                                if averaging
                                    swp1='Average_';
                                end
                                swp=[swp1 'Sweeps'];    
                                if any(continuous(:)>1)
                                     for s=1:size(swpnums,2)
                                        swp=[swp sprintf('_%d',swpnums(s)) ];
                                    end   
                                    % i.e. non-continuous array
                                else
                                swp=sprintf('%s-%d-%d',swp,swpnums(1),swpnums(end));
                                end
                            end
                            gtitle = sprintf('%sFile_%s_%s',spath,fnamepre,swp);
                            print('-fillpage',gtitle,'-dpdf')
                            end
                            %saveas (gcf,gtitle,'pdf');
                        end
                    end
                    hold off;
                    end
                    %
                    %cmd1=sprintf('psmerge -o%s.ps *eps ; ps2pdf %s.ps %s.pdf;',f,f,f);
                    % cmd1=sprintf('gs -sDEVICE=pdfwrite -dNOPAUSE -dBATCH -dSAFER -dQUIET  -sOutputFile=%s.pdf *PAGE* && rm *PAGE*;',f);
                    %cmd1=sprintf('gs -sDEVICE=pdfwrite -dNOPAUSE -dBATCH -dSAFER  -sFONTPATH=/usr/local/share/fonts/default/Type1 -sOutputFile=%s.pdf *eps;',fnamepre);
                    % system(cmd1);
                  catch e
                                  waitfor(msgbox({e.message; ['function ' e.stack(1).name]; ['line ' num2str(e.stack(1).line)]; ['File ' fnamepre ]},'Error in tdtmua'));
                      
                    %f=sprintf('Error in file %s -> %s',fnamepre,e.message);
                    %disp(f);
                  
                end
            end
        end
    end
end
end







